#include "manager.h"


Condomino* readCondomini(char* fileName, int *dim)
{
    int i = 0;
    Condomino temp;
    Condomino *c;
    
    // Apertura del file di input
	FILE* fp = NULL;
	if ((fp = fopen(fileName, "r")) == NULL) {
		printf("Impossibile aprire il file \"%s\"\n", fileName);
		exit(1);
	}
    
    (*dim) = 0;
    
    while(fscanf(fp,"%d %d %s %d",&temp.cod_condominio ,&temp.cap,temp.indirizzo,&temp.civico)==4)
        (*dim)++;
    
    c = (Condomino *)malloc((*dim) * sizeof(Condomino));
    
    rewind(fp);
    
    while(fscanf(fp,"%d %d %s %d",&(c[i]).cod_condominio ,&(c[i]).cap,(c[i]).indirizzo,&(c[i]).civico)==4)
        i++;
    
    // chiusura del file
	fclose(fp);

    return c;
}


ComA* readComA(char* fileName, int *dim){
    ComA *a;
    char cod;
    int i = 0;
    // char buffer[120];
    
    // Apertura del file di input
	FILE* fp = NULL;
	if ((fp = fopen(fileName, "r")) == NULL) {
		printf("Impossibile aprire il file \"%s\"\n", fileName);
		exit(1);
	}
    
    (*dim) = 0;
    while(fscanf(fp,"%c", &cod)==1)
    {
        if(cod=='A') {
            fscanf(fp,"%*d %*s");
            (*dim)++;
        }
        else {
            fscanf(fp,"%*d %*d %*s %*d %*d %*d");
        }
    }
    
    a = (ComA*) malloc(sizeof(ComA)*(*dim));
    rewind(fp);
    
    
    while(fscanf(fp,"%c", &cod)==1)
    {
        if(cod=='A')
        {
            fscanf(fp,"%d %s",&a[i].cod_condominio,a[i].comunicazione);
            i++;
        }
        else
        {
            fscanf(fp,"%*d %*d %*s %*d %*d %*d");
        }
    }

    
    
    // chiusura del file
	fclose(fp);

    return a;
}

ComE* readComE(char* fileName, int *dim){
    ComE *e;
    char cod;
    int i = 0;
    // char buffer[120];
    
    // Apertura del file di input
	FILE* fp = NULL;
	if ((fp = fopen(fileName, "r")) == NULL) {
		printf("Impossibile aprire il file \"%s\"\n", fileName);
		exit(1);
	}
    
    (*dim) = 0;
    while(fscanf(fp,"%c", &cod)==1)
    {
        if(cod=='E') {
            fscanf(fp,"%*d %*d %*s %*d %*d %*d");
            (*dim)++;
        }
        else {
            fscanf(fp,"%*d %*s");
        }
    }
    
    e = (ComE*) malloc(sizeof(ComE)*(*dim));
    rewind(fp);
    
    
    while(fscanf(fp,"%c", &cod)==1)
    {
        if(cod=='E')
        {
            fscanf(fp,"%d %d %s %d %d %d",&(e[i]).cod_condominio,&(e[i]).importo, e[i].descrizione, &(e[i]).aa,&(e[i]).mm,&(e[i]).gg);
            i++;
        }
        else
        {
            fscanf(fp,"%*d %*s");
        }
    }
    
    // chiusura del file
	fclose(fp);
    
    return e;
}


/*
 * Controllo se x è < di y
 *
 */
 
 int min(ComE *x, ComE *y)
{
    if((*x).aa < (*y).aa)
        return 1;
    if((*x).aa == (*y).aa && (*x).mm < (*y).mm)
        return 1;
    if((*x).aa == (*y).aa &&(*x).mm == (*y).mm && (*x).gg < (*y).gg)
        return 1;

    return 0;
}


/*
 * Scambia il contanuto delle due variabili
 * indirizzate dai puntatori x e y.
 */

void scambia(ComE *x, ComE *y) {
    ComE z;
    
    z = *x;
    *x = *y;
    *y = z;
}


/*
 * Funzione che implementa l'algoritmo Bubble sort.
 * Riceve come argomento l'array ed il numero di
 * elementi contenuti nell'array. Non restituisce alcun
 * valore, ma modifica il contenuto dell'array, ordinandolo.
 */

void bubble_sort(ComE x[], int n) {
    int flag=1, k=n-1, i;
    
    while (flag == 1 && k > 0) {
        flag = 0;
        for (i=0; i<k; i++) {
            if (! min(&x[i],&x[i+1])) {
                scambia(&x[i], &x[i+1]);
                flag = 1;
            }
        }
        k = k-1;
    }
    return;
}

ComE* stampaCondominio(Condomino *c, int dimC, ComA *a, int dimA, ComE *e, int dimE){
    
    int cod = 0;
    int i;
    int find = 1;
    
    printf("inserisci il codice condominio: ");
    scanf("%d", &cod);
    
    for(i = 0; i< dimC && find ; ++i)
        if(cod == c[i].cod_condominio)
        {
            find = 0;
            printf("Condominio: %d, %d %s %d\n", c[i].cod_condominio,c[i].cap,c[i].indirizzo,c[i].civico);
        }
    
    if(find)
    {
        printf("il codice condominio inserito è sbagliato\n ");
        exit(1);
     }
    
    for(i = 0; i< dimA ; ++i)
        if(cod == a[i].cod_condominio)
            printf("ComA: %d, %s\n", a[i].cod_condominio,a[i].comunicazione);


    
    //ordino ee
    bubble_sort(e,dimE);
    
    for(i = 0; i< dimE ; ++i)
        if(cod == e[i].cod_condominio)
            printf("ComE: %d %d %s %d/%d/%d\n",e[i].cod_condominio,(e[i]).importo, e[i].descrizione, (e[i]).aa,(e[i]).mm,(e[i]).gg);

    return e;

    
}
